## minexpert2 8.1.1

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.12)

############################################################
############################################################
# Basic information about project

project(mineXpert2
  DESCRIPTION "A program to visualize and explore mass spectrometric data"
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")

set(VERSION 8.1.1)

# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2021 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
add_definitions(-Wall -pedantic)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX AND NOT APPLE)
  # Run the following cmake command line:
  # cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development

  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(APPLE)
  # Run the following cmake command line:
  # cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=0 ../../development

  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


# QCustomPlot

if(NOT QCustomPlot_FOUND)
  message("Still searching for QCustomPlot")
  set(QCustomPlot_DIR ${CMAKE_MODULE_PATH})
  find_package(QCustomPlot REQUIRED)
  add_definitions(-DQCUSTOMPLOT_USE_LIBRARY)
endif()


# OPENMP
message(STATUS "${BoldYellow}OpenMP support is compulsory.${ColourReset}")
if(NOT OpenMP_FOUND)
  include(FindOpenMP)
  if(OpenMP_FOUND)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  else()
    message(STATUS "ERROR: OpenMP could not be found.")
  endif()
endif()


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")


# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
  ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX AND NOT APPLE)
  execute_process(COMMAND convert ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg
    ${CMAKE_SOURCE_DIR}/images/splashscreen.png)
endif()

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "BIN_DIR: ${BIN_DIR}")
message(STATUS "DOC_DIR: ${DOC_DIR}")


#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
message(STATUS "Adding subdirectory doc for project: ${CMAKE_PROJECT_NAME}")
add_subdirectory(doc)


# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)


#############################################################
####################
# BUILD OF THE TESTS
if(MAKE_TESTS)
  #MESSAGE("MAKE_TEST was set to ${MAKE_TEST}")
  enable_testing()
  include(CTest)

  if(BUILD_TESTING)

  add_subdirectory(tests)

  endif(BUILD_TESTING)

endif()


#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}BIN_DIR: ${BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
  message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
  message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}") 
message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
message("")

message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== src/CMakeLists.txt ===
message(\n${BoldRed}"Now configuring src/ for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)


########################################################
# Files
set(${TARGET}_nongui_SRCS
  #
  # Some globals.
  nongui/globals.cpp
  #
  # The classes for the IsoSpec calculations.
  nongui/Atom.cpp
  nongui/AtomCount.cpp
  nongui/Formula.cpp
  nongui/IsoSpecEntity.cpp
  nongui/Isotope.cpp
  nongui/Ponderable.cpp
  #
  # The main class that hold the mass data.
  nongui/MsRunDataSet.cpp
  #
  # The class to handle the statistics computation about a given MsRunDataSet.
  nongui/MsRunDataSetStats.cpp

  nongui/MassSpecDataFileLoader.cpp
  #
  # The classe that monitors integrators.
  nongui/MassDataIntegratorTask.cpp
  #
  # The base class of the integrators.
  nongui/MassDataIntegrator.cpp
  #
  # The various integrators that use BaseMsRunDataSetTreeNodeVisitor.
  nongui/MsRunDataSetTreeMassDataIntegratorToRt.cpp
  #nongui/MsRunDataSetTreeMassDataIntegratorToMz.cpp
  #nongui/MsRunDataSetTreeMassDataIntegratorToDt.cpp
  #nongui/MsRunDataSetTreeMassDataIntegratorToDtRtMz.cpp
  #nongui/MsRunDataSetTreeMassDataIntegratorToTicInt.cpp
  #
  # The various MsRunDataSetTreeNodeVisitor classes.
  nongui/BaseMsRunDataSetTreeNodeVisitor.cpp
  nongui/MsRunStatisticsTreeNodeVisitor.cpp
  nongui/TicChromTreeNodeCombinerVisitor.cpp
  #nongui/IntensityTreeNodeCombinerVisitor.cpp
  #nongui/RtDtMzColorMapsTreeNodeCombinerVisitor.cpp
  #nongui/RtDtColorMapTreeNodeCombinerVisitor.cpp
  #nongui/TraceTreeNodeCombinerVisitor.cpp
  #nongui/MassSpectrumTreeNodeCombinerVisitor.cpp
  #nongui/DriftSpectrumTreeNodeCombinerVisitor.cpp
  nongui/MultiTreeNodeCombinerVisitor.cpp
  #
  # The various integrators that use QualifiedMassSpectrumVector.
  nongui/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToTicInt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDtRtMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRtDt.cpp
  #
  # The classes that handle the processing flow
  nongui/ProcessingFlow.cpp
  nongui/ProcessingStep.cpp
  nongui/ProcessingType.cpp
  #
  # The classes that handle the parameters for the various integrations and the
  # display of traces.
  nongui/MsFragmentationSpec.cpp
  #
  # Peak-shaping classes (Gaussian Lorentzian peak shapes).
  nongui/MassPeakShaperConfig.cpp
  nongui/MassPeakShaper.cpp
  #
  # Analysis preferences
  nongui/AnalysisPreferences.cpp
  )

set(${TARGET}_gui_SRCS
  main.cpp
  gui/Application.cpp
  gui/ProgramWindow.cpp
  gui/MsRunSelectorDlg.cpp
  gui/AboutDlg.cpp
  #
  gui/ConsoleWnd.cpp
  #
  gui/MsRunReadTask.cpp
  #
  gui/OpenMsRunDataSetsDlg.cpp
  gui/ColorSelector.cpp
  #
  gui/TaskMonitorCompositeWidget.cpp
  gui/TaskMonitorWnd.cpp
  #
  # The ms run data set tree view classes
  gui/MsRunDataSetTableViewWnd.cpp
  gui/MsRunDataSetTableViewItem.cpp
  gui/MsRunDataSetTableView.cpp
  gui/MsRunDataSetTableViewModel.cpp
  gui/MsRunDataSetTableViewProxyModel.cpp
  #	
  # The MS fragmentation specification dialog
  gui/MsFragmentationSpecDlg.cpp
  gui/MzIntegrationParamsDlg.cpp
  #
  # The data plot graph/widget tree classes
  gui/DataPlottableNode.cpp
  gui/DataPlottableTree.cpp
  #
  # The trace plot widgets derived from pappso::BaseTracePlotWidget
  gui/TicXicChromTracePlotWidget.cpp
  gui/MassSpecTracePlotWidget.cpp
  gui/DriftSpecTracePlotWidget.cpp
  #
  # The trace plot composite widgets
  gui/BasePlotCompositeWidget.cpp
  gui/BaseTracePlotCompositeWidget.cpp
  gui/TicXicChromTracePlotCompositeWidget.cpp
  gui/MassSpecTracePlotCompositeWidget.cpp
  gui/DriftSpecTracePlotCompositeWidget.cpp
  #
  # The color map plot composite widgets
  gui/BaseColorMapPlotCompositeWidget.cpp
  gui/TicXicChromMassSpecColorMapPlotCompositeWidget.cpp
  gui/TicXicChromDriftSpecColorMapPlotCompositeWidget.cpp
  gui/DriftSpecMassSpecColorMapPlotCompositeWidget.cpp
  #
  # The plot windows
  gui/BasePlotWnd.cpp
  #	
  # Trace plot windows
  gui/BaseTracePlotWnd.cpp
  gui/BaseColorMapPlotWnd.cpp
  gui/TicXicChromTracePlotWnd.cpp
  gui/MassSpecTracePlotWnd.cpp
  gui/DriftSpecTracePlotWnd.cpp
  #
  # Color map plot windows
  gui/TicXicChromMassSpecColorMapWnd.cpp
  gui/TicXicChromDriftSpecColorMapWnd.cpp
  gui/DriftSpecMassSpecColorMapWnd.cpp
  #
  # The save plot to graphics file
  gui/SaveToGraphicsFileDlg.cpp
  #
  # The IsoSpec computations-related widgets
  gui/IsoSpecDlg.cpp
  gui/IsoSpecTableView.cpp
  gui/IsoSpecTableViewModel.cpp
  gui/MassPeakShaperDlg.cpp
  #
  # The ProcessingFlow viewer dialog window
  gui/ProcessingFlowViewerDlg.cpp
  #
  # The XIC chromatogram feature
  gui/XicExtractionWnd.cpp
  #
  # Analysis preferences
  gui/AnalysisPreferencesDlg.cpp
  )

set(${TARGET}_UIS
  gui/ui/AboutDlg.ui
  gui/ui/MsRunSelectorDlg.ui
  gui/ui/OpenMsRunDataSetsDlg.ui
  gui/ui/MsRunDataSetTableViewWnd.ui
  gui/ui/BasePlotWnd.ui
  gui/ui/BasePlotCompositeWidget.ui
  gui/ui/TaskMonitorCompositeWidget.ui
  gui/ui/TaskMonitorWnd.ui
  gui/ui/ConsoleWnd.ui
  gui/ui/MsFragmentationSpecDlg.ui
  gui/ui/MzIntegrationParamsDlg.ui
  gui/ui/SaveToGraphicsFileDlg.ui
  gui/ui/IsoSpecDlg.ui
  gui/ui/MassPeakShaperDlg.ui	
  gui/ui/ElementGroupBoxWidget.ui
  gui/ui/ProcessingFlowViewerDlg.ui
  gui/ui/XicExtractionWnd.ui
  gui/ui/AnalysisPreferencesDlg.ui)


find_package(Qt5 COMPONENTS Widgets Xml Svg PrintSupport REQUIRED)

qt5_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt5_add_resources(${TARGET}_QRC_CPP ../minexpert2.qrc)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
# NOT sure about this. Let's comment that for the moment.
# set_source_files_properties(${${TARGET}_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
# set_source_files_properties(${${TARGET}_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)

include_directories(

  # The config file is binary directory-specific !!!
  # For the config.h file generated from config.h.in
  # For the ui_Xyyyyy.h files
  ${CMAKE_CURRENT_BINARY_DIR}

  # For all the source subdirectories
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}

  ${Qt5Widgets_INCLUDE_DIRS}
  ${Qt5Xml_INCLUDE_DIRS}
  ${Qt5Svg_INCLUDE_DIRS}
  ${Qt5Sql_INCLUDE_DIRS}
  ${Qt5PrintSupport_INCLUDE_DIRS}
  ${IsoSpec++_INCLUDE_DIRS}
  )


###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

  add_executable(${TARGET} WIN32
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
    )

elseif(UNIX AND NOT APPLE)

  add_executable(${TARGET}
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
    )

elseif(APPLE)

  add_executable(${TARGET} MACOSX_BUNDLE
    ${${TARGET}-exec_SRCS}
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
    ../images/icons/${TARGET}.icns
    )

  set_target_properties(${TARGET} PROPERTIES 
    MACOSX_BUNDLE_ICON_FILE ${TARGET}.icns)

  # We need to specify that manually because FindOpenMP() does 
  # not work on macports as of 20200727.
  target_include_directories(${TARGET}
    PUBLIC ${OpenMP_INCLUDE_DIRS})
  target_link_libraries(${TARGET}
    OpenMP::OpenMP)

endif()


# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
  Qt5::Widgets
  Qt5::Xml
  Qt5::Svg
  Qt5::PrintSupport
  QCustomPlot::QCustomPlot
  IsoSpec++::IsoSpec++
  PappsoMSpp::Core
  PappsoMSpp::Widget
  )


#### Debugging stuff
message(STATUS required_target_link_libraries: ${required_target_link_libraries})

message(STATUS "Now printing all the include directories -I...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "included dir='${dir}'")
endforeach()

message(STATUS "Now printing all the linking directories -L...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY LINK_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "link directory dir='${dir}'")
endforeach()

if(PROFILE)
  message(STATUS "Profiling is requested, adding linker -pg flag.")
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
  # We want to install the binary arch-dependent target in
  # specific situations. To have proper control, we define the arch
  # component.
  install(TARGETS ${TARGET}
    RUNTIME
    COMPONENT arch
    DESTINATION ${BIN_DIR})
endif()


message("")
message(STATUS "${BoldGreen}Finished configuring of ${TARGET}.${ColourReset}")
message("")

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  message("")
  message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
  message("")

  # The version of the program needs to be set in the user manual front
  # matter.
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

  # Command:
  # make minexpert-doc
  # Makes use of the local  Makefile file.
  # Will generate HTML and PDF documentation in the build directory

  # Note that TARGET needs to be lowercase. Since we build the documentation
  # only on UNIX, that target is set in
  # CMakeStuff/toolchains/unix-toolchain.cmake.

  add_custom_target(${TARGET}-doc ALL
    COMMAND make all
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "DocBook-based user manual documentation for ${CMAKE_PROJECT_NAME}")

  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/build/minexpert2-user-manual/${TARGET}-doc.pdf
    DESTINATION ${DOC_DIR})

  install(DIRECTORY 
    ${CMAKE_CURRENT_SOURCE_DIR}/build/${TARGET}-user-manual/html/${TARGET}-user-manual/
    DESTINATION ${DOC_DIR}/html)

  message("")
  message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
  message("")

else()

  message(STATUS "User manual build skipped")

endif()

=== debian/changelog ===
minexpert2 (8.1.1-1) unstable; urgency=low

  * New upstream release improving the setting of the low/high filtering
    configuration for color map data.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 26 Apr 2021 13:24:01 +0200

minexpert2 (8.1.0-1) unstable; urgency=low

  * New upstream version adding signal-to-noise ratio enhancement features for
    the color maps.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 21 Apr 2021 13:06:20 +0200

minexpert2 (8.0.3-1) unstable; urgency=low

  * New version with a reworked icon system based on svg files and not png
    ones.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 15 Apr 2021 16:56:48 +0200

minexpert2 (8.0.2-2) unstable; urgency=low

  * Build that depends on new ABI of pappsomspp libs.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Apr 2021 21:48:05 +0200

minexpert2 (8.0.2-1) unstable; urgency=low

  * New version to build with libpappsomspp 0.8.23 that provides a workaround
    the failing tests on i386.

  * Other small changes.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 31 Mar 2021 15:00:05 +0200

minexpert2 (8.0.1-1) unstable; urgency=low

  * Fixes to the documentation (new figures with much more interesting data
    set to document the skewed selection polygon feature).

  * Provide the new bibliographic reference for citation in the Help dialog
    box.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 24 Mar 2021 11:20:13 +0100

minexpert2 (8.0.0-1) unstable; urgency=low

  * New major release with the skewed selection polygon feature.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 23 Mar 2021 16:49:24 +0100

minexpert2 (7.4.1-2) unstable; urgency=low

  * Update dependencies for libpappsomspp-dev (>= 0.8.18),
    libpappsomspp-widget-dev (>= 0.8.18).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 03 Mar 2021 09:24:56 +0100

=== debian/control ===
Source: minexpert2
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.18.25),
 graphicsmagick-imagemagick-compat,
 libgomp1,
 qtbase5-dev (>= 5.11.3),
 libqt5svg5-dev (>= 5.11.3),
 cmake (>= 3.12),
 daps (>= 3.0.0),
 libjeuclid-core-java,
 libjeuclid-fop-java,
 docbook-mathml,
 libjs-jquery,
 libjs-highlight.js,
 libjs-mathjax,
 fonts-mathjax,
 fonts-mathjax-extras,
 texlive-fonts-extra (>= 2020.20210202),
 fonts-ebgaramond-extra,
 gsfonts,
 libqcustomplot-dev(>= 2.0),
 libisospec++-dev (>=2.1.3),
 libpappsomspp-dev (>= 0.8.25),
 libpappsomspp-widget-dev (>= 0.8.25),
 docbook-to-man,
 qttools5-dev-tools,
 qtchooser
Standards-Version: 4.5.1
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert2
Vcs-Git: https://salsa.debian.org/debichem-team/minexpert2.git


Package: minexpert2
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: minexpert2-doc (>= ${source:Upstream-Version})
Replaces: msxpertsuite-minexpert (<< 6.0.0)
Breaks: msxpertsuite-minexpert (<< 6.0.0)
Conflicts: msxpertsuite-minexpert
Description: MS^n mass spectrometric data visualization and mining (runtime)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data 
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a 
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the 
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based 
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric 
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the mineXpert2 program.


Package: minexpert2-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: msxpertsuite-minexpert-data-doc (<< 6.0.0)
Breaks: msxpertsuite-minexpert-data-doc (<< 6.0.0)
Conflicts: msxpertsuite-minexpert-data-doc
Description: MS^n mass spectrometric data visualization and mining (doc)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data 
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a 
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the 
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based 
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric 
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the user manual in both PDF and HTML formats.

## minexpert2 8.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 8.1.1)
+set(VERSION 8.2.0)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
@@ -21,9 +21,10 @@
 
 include(GNUInstallDirs)
 
-set(HOME_DEVEL_DIR $ENV{HOME}/devel)
-message("\n${BoldRed}The devel directory where all the development projects
-should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")
+#set(HOME_DEVEL_DIR $ENV{HOME}/devel)
+#message("\n${BoldRed}The devel directory where all the development projects
+#should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")
+
 
 # Add folder where are supportive functions
 set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
@@ -110,6 +111,26 @@
   endif()
 
 elseif(UNIX AND NOT APPLE)
+  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
+  # need to be installed and they ship the PappsoMSppConfig.cmake
+  # config file.
+
+  # However, when developing both libs and this program, we need to be able to
+  # load the libs from their dev/build directory without relying on the system
+  # libs.
+  if(LOCAL_DEV)
+    # The development should use the locally built libs.
+    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
+  else()
+    # The development should use the system-wide libs.
+    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
+
+  endif()
+
+  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
+  message(STATUS "PappsoMSpp and PappsoMSppWidget were found:
+  \t${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")
+
   # Run the following cmake command line:
   # cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development
 
@@ -243,7 +264,7 @@
 
   if(BUILD_TESTING)
 
-  add_subdirectory(tests)
+    add_subdirectory(tests)
 
   endif(BUILD_TESTING)
 
@@ -292,6 +313,12 @@
 message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
 message("")
 
+if(LOCAL_DEV)
+  message("")
+  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMSPP")
+  message("")
+endif()
+
 message("")
 message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
 message("")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

	message(STATUS "Going to generate the man pages.")

	execute_process(COMMAND docbook-to-man minexpert2.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/minexpert2.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX AND NOT APPLE)


###############
# install stuff

# The history and licence files.

message("Installing the doc files in ${DOC_DIR}")
install(FILES history.html ../LICENSE
	DESTINATION ${DOC_DIR})

# The man page.
if(UNIX AND NOT APPLE)
	install(FILES ${CMAKE_BINARY_DIR}/minexpert2.1
		${CMAKE_BINARY_DIR}/minexpert2.1
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUALS

if(BUILD_USER_MANUAL)
	add_subdirectory(user-manual)
endif()


message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
   nongui/BaseMsRunDataSetTreeNodeVisitor.cpp
   nongui/MsRunStatisticsTreeNodeVisitor.cpp
   nongui/TicChromTreeNodeCombinerVisitor.cpp
+  nongui/TicChromatogramFromMassSpecDataFile.cpp
   #nongui/IntensityTreeNodeCombinerVisitor.cpp
   #nongui/RtDtMzColorMapsTreeNodeCombinerVisitor.cpp
   #nongui/RtDtColorMapTreeNodeCombinerVisitor.cpp
@@ -101,7 +102,12 @@
   #	
   # The MS fragmentation specification dialog
   gui/MsFragmentationSpecDlg.cpp
+  #
+  # The M/Z integration parameters dialog
   gui/MzIntegrationParamsDlg.cpp
+  #
+  # The Savitzky-Golay filter params dialog
+  gui/SavitzkyGolayFilterParamsDlg.cpp
   #
   # The data plot graph/widget tree classes
   gui/DataPlottableNode.cpp
@@ -157,6 +163,13 @@
   #
   # Analysis preferences
   gui/AnalysisPreferencesDlg.cpp
+  #
+  # Labelled widget-based QAction classes
+  gui/LabelledDoubleSpinBoxAction.cpp
+  gui/LabelledNumberLineEditAction.cpp
+  #
+  # Plot overlay transparent widget
+  gui/PlotAreaOverlay.cpp
   )
 
 set(${TARGET}_UIS
@@ -171,6 +184,7 @@
   gui/ui/ConsoleWnd.ui
   gui/ui/MsFragmentationSpecDlg.ui
   gui/ui/MzIntegrationParamsDlg.ui
+  gui/ui/SavitzkyGolayFilterParamsDlg.ui
   gui/ui/SaveToGraphicsFileDlg.ui
   gui/ui/IsoSpecDlg.ui
   gui/ui/MassPeakShaperDlg.ui

=== doc/user-manual/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,12 @@
   # matter.
   CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
     ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)
+
+  # The location of the main user manual config file (set fop.xconf file
+  # location)
+  set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
+  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
+    ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)
 
   # Command:
   # make minexpert-doc
@@ -24,11 +30,11 @@
     COMMENT "DocBook-based user manual documentation for ${CMAKE_PROJECT_NAME}")
 
   install(FILES
-    ${CMAKE_CURRENT_SOURCE_DIR}/build/minexpert2-user-manual/${TARGET}-doc.pdf
+    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/${TARGET}-doc.pdf
     DESTINATION ${DOC_DIR})
 
   install(DIRECTORY 
-    ${CMAKE_CURRENT_SOURCE_DIR}/build/${TARGET}-user-manual/html/${TARGET}-user-manual/
+    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/html/user-manual/
     DESTINATION ${DOC_DIR}/html)
 
   message("")

=== doc/user-manual/Makefile ===
project=minexpert2

topDir=$(CURDIR)

okularPid=${topDir}/okular.pid

pdfFilePath=${topDir}/build/user-manual
pdfFilePathName=${pdfFilePath}/user-manual_color_en.pdf 
htmlDirPath=${topDir}/build/user-manual/html/${project}-user-manual

default: all

all: pdf html

all_f: pdf_f html_f

all_f_r: pdf_f_r html_f_r

.PHONY: reader
reader:
	okular --geometry 1268x1099-0-34 $(pdfFilePathName) & echo $$! > okular.pid

# Make the pdf file without forcing without reload
pdf:
	daps -d ${topDir}/DC-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Make the pdf file with forcing remaking all the targets and without reload
pdf_f:
	daps --force -d ${topDir}/DC-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_r: pdf
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_f_r: pdf_f
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

.PHONY: html
html:
	daps -d ${topDir}/DC-user-manual --verbosity=3 html --static

.PHONY: html_f
html_f: html
	daps --force -d ${topDir}/DC-user-manual --verbosity=3 html --static

.PHONY: html_r
html_r: html
	firefox-reload-page.sh

.PHONY: html_f_r
html_f_r: html_f
	firefox-reload-page.sh

package_html:
	daps -d ${topDir}/DC-user-manual package-html

check_dir:
	echo "mkfile_path: $(mkfile_path)"
	echo "current_dir: $(current_dir)"	

	if [ -d "xml" ];\
	 	then \
		echo "Not in a user manual top source directory.";\
		exit 1;\
		fi

=== debian/changelog ===
minexpert2 (8.2.0-1) unstable; urgency=low

  * New upstream version with a new low intensity threshold removal filter.

  * Updated the user manual.

  * Remove the docbook-mathml, libjeuclid-core-java, libjeuclid-fop-java,
    libjs-mathjax, fonts-mathjax, fonts-mathjax-extras, dependencies and add
    docbook-xml. That should fix the problem related to bug #994795.

  * Standards-Version: 4.6.0

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 19 Nov 2021 17:19:11 +0100

=== debian/control ===
--- 
+++ 
@@ -11,25 +11,20 @@
  libqt5svg5-dev (>= 5.11.3),
  cmake (>= 3.12),
  daps (>= 3.0.0),
- libjeuclid-core-java,
- libjeuclid-fop-java,
- docbook-mathml,
  libjs-jquery,
  libjs-highlight.js,
- libjs-mathjax,
- fonts-mathjax,
- fonts-mathjax-extras,
  texlive-fonts-extra (>= 2020.20210202),
  fonts-ebgaramond-extra,
  gsfonts,
  libqcustomplot-dev(>= 2.0),
  libisospec++-dev (>=2.1.3),
- libpappsomspp-dev (>= 0.8.25),
- libpappsomspp-widget-dev (>= 0.8.25),
+ libpappsomspp-dev (>= 0.8.48),
+ libpappsomspp-widget-dev (>= 0.8.48),
+ docbook-xml,
  docbook-to-man,
  qttools5-dev-tools,
  qtchooser
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: http://www.msxpertsuite.org/
 Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert2
 Vcs-Git: https://salsa.debian.org/debichem-team/minexpert2.git

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

	# Ensure that the fop.xconf file is found in the DC* files
	# that are located in $(CURDIR)/doc/user-manual

	cd doc/user-manual && \
		sed -i 's|/home/rusconi/devel/minexpert2/development/doc/user-manual/fop.xconf|$(CURDIR)/doc/user-manual/fop.xconf|' DC-user-manual

override_dh_auto_build:
	cd debian/build && make

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install

## minexpert2 8.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,19 +11,18 @@
   DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 8.2.0)
+set(VERSION 8.3.0)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
-set(COPYRIGHT "Copyright (c) 2008-2021 Filippo Rusconi. Licensed under GPLv3+")
+set(COPYRIGHT "Copyright (c) 2008-2022 Filippo Rusconi. Licensed under GPLv3+")
 set(IDENTIFIER "org.msxpertsuite")
 
 
 include(GNUInstallDirs)
 
-#set(HOME_DEVEL_DIR $ENV{HOME}/devel)
-#message("\n${BoldRed}The devel directory where all the development projects
-#should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")
+set(HOME_DEVEL_DIR $ENV{HOME}/devel)
+message("\n${BoldRed}The devel directory where all the development projects should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")
 
 
 # Add folder where are supportive functions
@@ -228,7 +227,7 @@
 ######################
 # BUILD OF THE PROGRAM
 
-message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
+message(STATUS "Adding subdirectory src for project: ${CMAKE_PROJECT_NAME}")
 add_subdirectory(src)
 
 ####################################################

=== debian/changelog ===
minexpert2 (8.3.0-1) unstable; urgency=low

  * Improve significantly the navigation in the plots (thanks to Kevin
    Hooijschuur for useful discussion in front of my poster at the ASMS
    conference). Fixes https://gitlab.com/msxpertsuite/minexpert2/-/issues/5.

  * Fix crash ocurring when showing back a previously plot window (thanks to
    Kevin Hooijschuur for the bug report). Fixes
    https://gitlab.com/msxpertsuite/minexpert2/-/issues/2.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 17 Jun 2022 11:57:08 +0200

minexpert2 (8.2.1-1) UNRELEASED; urgency=low

  * New version:

  * Better handle the cross-compilation in the MXE environment;
  * Ensure that the user manual is found in the AppImage bundle environment.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 24 Feb 2022 18:57:31 +0100

=== debian/control ===
--- 
+++ 
@@ -18,8 +18,8 @@
  gsfonts,
  libqcustomplot-dev(>= 2.0),
  libisospec++-dev (>=2.1.3),
- libpappsomspp-dev (>= 0.8.48),
- libpappsomspp-widget-dev (>= 0.8.48),
+ libpappsomspp-dev (>= 0.8.50),
+ libpappsomspp-widget-dev (>= 0.8.50),
  docbook-xml,
  docbook-to-man,
  qttools5-dev-tools,

## minexpert2 8.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 8.3.0)
+set(VERSION 8.5.0)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")

=== debian/changelog ===
minexpert2 (8.5.0-2) unstable; urgency=low

  * Update dependency over libpappsomspp.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 11 Jul 2022 14:15:03 +0200

minexpert2 (8.5.0-1) unstable; urgency=low

  * New upstream release fixes a bug in the handling of the color map plot pan
    when axes are locked.

  * Updated dependency on libpappsomspp version 0.8.54.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 08 Jul 2022 20:09:24 +0200

minexpert2 (8.4.0-1) unstable; urgency=low

  * New upstream version that implements settable m/z resolution for the color
    map calculations when they involve m/z as one dimension (this feature was
    requested by Dr Valery Voinov of eMSion).

  * Update of the user manual to document the above new feature.

  * Depend on more recent version of libpappsomspp.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 29 Jun 2022 20:13:44 +0200

=== debian/control ===
--- 
+++ 
@@ -18,8 +18,8 @@
  gsfonts,
  libqcustomplot-dev(>= 2.0),
  libisospec++-dev (>=2.1.3),
- libpappsomspp-dev (>= 0.8.50),
- libpappsomspp-widget-dev (>= 0.8.50),
+ libpappsomspp-dev (>= 0.8.54),
+ libpappsomspp-widget-dev (>= 0.8.54),
  docbook-xml,
  docbook-to-man,
  qttools5-dev-tools,

## minexpert2 8.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 8.5.0)
+set(VERSION 8.5.1)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")

=== debian/changelog ===
minexpert2 (8.5.1-1) unstable; urgency=low

  * Fix regression with the start of mass integrations.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 11 Jul 2022 16:37:12 +0200

## minexpert2 8.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 8.5.1)
+set(VERSION 8.5.2)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
@@ -110,6 +110,9 @@
   endif()
 
 elseif(UNIX AND NOT APPLE)
+
+  #message("UNIX AND NOT APPLE")
+
   # On UNIX, the libpappsomspp and libpappsomspp-widget libs
   # need to be installed and they ship the PappsoMSppConfig.cmake
   # config file.
@@ -119,6 +122,7 @@
   # libs.
   if(LOCAL_DEV)
     # The development should use the locally built libs.
+    message("Using the local libpappsomspp libraries.")
     include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
   else()
     # The development should use the system-wide libs.
@@ -129,11 +133,6 @@
   message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
   message(STATUS "PappsoMSpp and PappsoMSppWidget were found:
   \t${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")
-
-  # Run the following cmake command line:
-  # cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development
-
-  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
 
 elseif(APPLE)
   # Run the following cmake command line:

=== doc/user-manual/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 default: all
 
-all: pdf html
+all: pdf_f html_f
 
 all_f: pdf_f html_f

=== debian/changelog ===
minexpert2 (8.5.2-1) unstable; urgency=low

  * New upstream release fixing "old cruft" bug where an integration from a
    color map (with one m/z dimension) to a color map (having also an m/z
    dimension) would occur as before, with setDecimals(0) and NO_BINNING.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 12 Jul 2022 14:25:26 +0200

=== debian/control ===
--- 
+++ 
@@ -18,8 +18,8 @@
  gsfonts,
  libqcustomplot-dev(>= 2.0),
  libisospec++-dev (>=2.1.3),
- libpappsomspp-dev (>= 0.8.54),
- libpappsomspp-widget-dev (>= 0.8.54),
+ libpappsomspp-dev (>= 0.8.55),
+ libpappsomspp-widget-dev (>= 0.8.55),
  docbook-xml,
  docbook-to-man,
  qttools5-dev-tools,
